%define sourcedir stable/%{version}/distribution/tar/generic/source
%define DATE 20010829
%define is_release 1
%define beta %{nil}
Version: 1.1.1
%define rel 2.3
%define VER %{version}%{beta}

Name: koffice
URL: http://koffice.kde.org/
Summary: A set of office applications for KDE.
%if %{is_release}
Source: ftp://ftp.kde.org/pub/kde/%{sourcedir}/%{name}-%{VER}.tar.bz2
%if "%{beta}" != ""
Release: 0.%{beta}.%{rel}
%else
Release: %{rel}
%endif
%else
Source: ftp://ftp.kde.org/pub/kde/%{sourcedir}/%{name}-%{DATE}.tar.bz2
Release: 0.cvs%{DATE}.%{rel}
%endif
Source1: %{name}-i18n-%{version}.tar.bz2
Source2: koshell.png
Patch: koffice-i18n-ac214.patch
Patch1: koffice-1.1.1-CVE-2006-6120.patch
Group: User Interface/Desktops
Obsoletes: killustrator kivio
License: GPL
BuildRoot: %{_tmppath}/%{name}-buildroot
Prefix: /usr
Prereq: kdelibs
Epoch: 3
Requires(post,postun): /sbin/ldconfig

%package devel
Summary: Development files for KOffice
Group: Development/Libraries

%description
The koffice package contains the KOffice office-type applications for
the K Desktop Environment (KDE) GUI desktop. KOffice contains KWord, a
word processor; KSpread, a spreadsheet; KPresenter, for presentations;
and KChart, a diagram generator.

%description devel
Development files for KOffice. Install koffice-devel if you want to develop
or compile plugins for KOffice.

%prep
rm -rf $RPM_BUILD_ROOT
%if %{is_release}
%setup -q
%else
%setup -q -n %{name}
%endif
%patch1 -p1 -b .CVE-2006-6120

%ifarch ia64
# FIXME - doesn't compile ATM.
rm -rf kivio
%endif

%ifarch alpha
# FIXME - doesn't compile ATM.
rm -rf filters/kspread/qpro
perl -pi -e "s,qpro,,g" filters/kspread/Makefile.am
%endif

[ -e Makefile.cvs ] && make -f Makefile.cvs

%build
unset QTDIR || : ; . /etc/profile.d/qt.sh
export KDEDIR=%{prefix}
if [ -x /usr/bin/getconf ]; then
  CPUS=`getconf _NPROCESSORS_ONLN`
fi
if test "x$CPUS" = "x" -o "x$CPUS" = "x0"; then
  CPUS=1
fi
CFLAGS="-D_GNU_SOURCE $RPM_OPT_FLAGS" CXXFLAGS="-D_GNU_SOURCE $RPM_OPT_FLAGS -DNO_DEBUG -DNDEBUG -fno-check-new" \
	./configure  \
	--prefix=%{prefix} \
	--includedir=%{prefix}/include/kde \
	--disable-final

make -j $CPUS

export OLD_PO_FILE_INPUT=yes
tar xjf %{SOURCE1}
cd koffice-i18n-%{version}
patch -p1 <%{PATCH0}
test -f Makefile.cvs && make -f Makefile.cvs
./configure --prefix=%{prefix}
make %{?smp_mflags}

%install
make RUN_KAPPFINDER=no DESTDIR=$RPM_BUILD_ROOT install-strip
if ! [ -e $RPM_BUILD_ROOT/usr/share/icons/hicolor/48x48/apps/koshell.png ]; then
	install -c -m 644 %{SOURCE2} $RPM_BUILD_ROOT/usr/share/icons/hicolor/48x48/apps/koshell.png
fi
rm -f $RPM_BUILD_ROOT/usr/share/icons/locolor/16x16/actions/bottom.png
rm -f $RPM_BUILD_ROOT/usr/share/icons/locolor/16x16/actions/rotate.png
rm -f $RPM_BUILD_ROOT/usr/share/icons/locolor/16x16/actions/top.png
rm -f $RPM_BUILD_ROOT/usr/share/icons/locolor/16x16/actions/wizard.png
rm -f $RPM_BUILD_ROOT/usr/share/icons/locolor/16x16/apps/kspreadcalc.png
rm -f $RPM_BUILD_ROOT/usr/share/icons/locolor/32x32/apps/kspreadcalc.png

{
	pushd $RPM_BUILD_ROOT
	find . -type d | egrep -v '(/usr$|/usr/include$|/usr/include/kde$|/usr/bin$|/usr/lib$|/usr/lib/kde2$|/usr/share$|/usr/share/applnk$|/usr/share/apps$|/usr/share/doc$|/usr/share/doc/HTML$|/usr/share/doc/HTML/en$|/usr/share/icons|/usr/share/mimelnk|/usr/share/services|/usr/share/servicetypes)' | sed '1,2d;s,^\.,\%attr(-\,root\,root) \%dir ,' > \
		$RPM_BUILD_DIR/file.list.%{name}

	find . -type f | grep -v '/usr/include' | sed -e 's,^\.,\%attr(-\,root\,root) ,' \
		-e '/\/config\//s|^|%config|' >> \
		$RPM_BUILD_DIR/file.list.%{name}

	find . -type l | sed 's,^\.,\%attr(-\,root\,root) ,' >> \
		$RPM_BUILD_DIR/file.list.%{name}
	popd
}

# Replace absolute symlinks with relative ones
pushd $RPM_BUILD_ROOT%{prefix}/share/doc/HTML/en
for i in *; do
	if [ -d $i -a -L $i/common ]; then
		rm -f $RPM_BUILD_ROOT%{prefix}/share/doc/HTML/en/$i/common
		ln -s ../common $RPM_BUILD_ROOT%{prefix}/share/doc/HTML/en/$i
	fi
done
popd

cd koffice-i18n-%{version}
make DESTDIR=$RPM_BUILD_ROOT install

# fix file permission
chmod 755 $RPM_BUILD_ROOT/%{prefix}/share/apps/koffice
chmod 755 $RPM_BUILD_ROOT/%{prefix}/share/doc/HTML/en/kspread

%clean
rm -rf $RPM_BUILD_ROOT $RPM_BUILD_DIR/file.list.%{name}

%files -f ../file.list.%{name} 
%defattr(-,root,root)
%lang(en_GB) %{prefix}/share/locale/en_GB/LC_MESSAGES/*
%lang(bg) %{prefix}/share/locale/bg/LC_MESSAGES/*
%lang(cs) %{prefix}/share/locale/cs/LC_MESSAGES/*
%lang(da) %{prefix}/share/locale/da/LC_MESSAGES/*
%lang(nl) %{prefix}/share/locale/nl/LC_MESSAGES/*
%lang(et) %{prefix}/share/locale/et/LC_MESSAGES/*
%lang(fr) %{prefix}/share/locale/fr/LC_MESSAGES/*
%lang(de) %{prefix}/share/locale/de/LC_MESSAGES/*
%lang(hu) %{prefix}/share/locale/hu/LC_MESSAGES/*
%lang(it) %{prefix}/share/locale/it/LC_MESSAGES/*
%lang(ja) %{prefix}/share/locale/ja/LC_MESSAGES/*
%lang(lt) %{prefix}/share/locale/lt/LC_MESSAGES/*
%lang(no) %{prefix}/share/locale/no/LC_MESSAGES/*
%lang(nn_NO) %{prefix}/share/locale/no_NY/LC_MESSAGES/*
%lang(pl) %{prefix}/share/locale/pl/LC_MESSAGES/*
%lang(pt) %{prefix}/share/locale/pt/LC_MESSAGES/*
%lang(ro) %{prefix}/share/locale/ro/LC_MESSAGES/*
%lang(ru) %{prefix}/share/locale/ru/LC_MESSAGES/*
%lang(sk) %{prefix}/share/locale/sk/LC_MESSAGES/*
%lang(sl) %{prefix}/share/locale/sl/LC_MESSAGES/*
%lang(sv) %{prefix}/share/locale/sv/LC_MESSAGES/*
%lang(es) %{prefix}/share/locale/es/LC_MESSAGES/*
%lang(tr) %{prefix}/share/locale/tr/LC_MESSAGES/*
%lang(pt_BR) %{prefix}/share/locale/pt_BR/LC_MESSAGES/*

%files devel
%defattr(-,root,root)
%{prefix}/include/kde/*

%post
/sbin/ldconfig
kbuildsycoca &>/dev/null || :

%postun -p /sbin/ldconfig

%changelog
* Mon Feb 19 2007 Than Ngo <than@redhat.com> - 1.1.1-2.3
- fix backport patch to fix #217738, CVE-2006-6120

* Tue Feb 13 2007 Than Ngo <than@redhat.com> 1.1.1-2.2
- fix file permission

* Tue Dec 05 2006 Than Ngo <than@redhat.com> - 1.1.1-2.1
- backport patch to fix #217738, CVE-2006-6120

* Wed Jan  9 2002 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.1-2
- Rename kra*** to kopaint

* Fri Dec 14 2001 Bernhard Rosenkraenzer <bero@redhat.com> 1.1.1-1
- 1.1.1

* Wed Aug 29 2001 Bernhard Rosenkraenzer <bero@redhat.com> 1.1-5
- Rebuild with new kdelibs

* Mon Aug 27 2001 Bernhard Rosenkraenzer <bero@redhat.com> 1.1-4
- Merge koffice-i18n into the package

* Thu Aug 23 2001 Bernhard Rosenkraenzer <bero@redhat.com> 1.1-3
- Add missing defattr to -devel (#52292)
- Remove dupes from kdeartwork-locolor (Part of #51589)

* Tue Aug 21 2001 Bernhard Rosenkraenzer <bero@redhat.com> 1.1-2
- Replace koshell icon (#51439)
- Move include files to the correct directory (/usr/include/kde rather than
  /usr/include)
- restore -devel package (it was lost in 1.1-1 for some reason)
- Don't own standard directories

* Tue Aug 14 2001 Bernhard Rosenkraenzer <bero@redhat.com> 1.1-1
- 1.1 final
- Add icon for koshell (#51439)

* Wed Jul 25 2001 Bernhard Rosenkraenzer <bero@redhat.com> 1.1-0.cvs20010725.1
- Increase Epoch

* Tue Jul 24 2001 Bernhard Rosenkraenzer <bero@redhat.com> 1.1-0.cvs20010724.1
- Don't build kivio on ia64 ATM (compiler bug)

* Tue Feb 20 2001 Than Ngo <than@redhat.com>
- update 2.1
- fix dangling symlinks

* Fri Feb  2 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Add ldconfig in %%post and %%postun, replace absolute symlinks
  with relative symlinks (#24878)

* Mon Jan 22 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Update

* Thu Jan 11 2001 Bernhard Rosenkraenzer <bero@redhat.com>
- Update
- Don't build on sparc and ia64 (Bug #23809)

* Sun Dec  3 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.0.1

* Fri Nov  3 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Update to KDE_2_0_BRANCH

* Mon Oct 16 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.0 final

* Tue Oct  3 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 2.0

* Mon Oct  2 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new CVS
- fix compilation

* Thu Aug 24 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- kill dupes from kdelibs

* Thu Aug 24 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- 1.93

* Sun Aug  6 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- update (fixed compilation with gcc 2.96 in CVS)
- work around compiler bugs on alpha

* Fri Aug  4 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot
- move to /usr/lib/kde2

* Thu Jul 27 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- rebuild

* Tue Jul 25 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot

* Sun Jul 23 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot, new Qt

* Thu Jul 13 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- Don't hardcode Qt version
- obsolete killustrator (powertools 6.x)
- SMPify

* Tue Jul 11 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- use gcc 2.96
- new snapshot

* Mon Jul  3 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- use kernelcc
- new snapshot

* Tue Jun 20 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot
- ExcludeArch ia64

* Sat Mar 18 2000 Bernhard Rosenkraenzer <bero@redhat.com>
- new snapshot
- move it to /usr, where it belongs

* Sat Oct 23 1999 Bernhard Rosenkraenzer <bero@redhat.de>
- Initial RPM
